

// Librerias necesarias
#include <OneWire.h>
#include <DallasTemperature.h>
#include <ESP8266WiFi.h>
ADC_MODE(ADC_VCC);
 

//OneWire  ds(5);
// define DS18B20 D5; 

String apiKey = "SEQNTRC4Y2JCZAGK";     //  Poner la apikey que te da ThingSpeak
const char* ssid =  "viv93";  // Poner el nombre de tu red wi-fi
const char* password =  "heladera2"; // Poner la contraseña de tu red wi-fi
const char* server = "api.thingspeak.com";// El servidor de Thingspeak, esto NO se modifica




// Defino variables numericas
float temp;// Variable para la temperatura leida
float temp2;
int veces;// Variable para los intentos de subir el dato de temperatura a la nube; para que en caso de apagón, no se gaste toda la batería intentando e intentando subir el dato.





#define Pin 5 
OneWire ourWire(Pin); //Se establece el pin declarado como bus para la comunicación OneWire
DallasTemperature sensors(&ourWire);
#define LED 0
DeviceAddress Thermometer;
int deviceCount = 0;
#define TEMPERATURE_PRECISION 12

//#define ONE_WIRE_BUS D2 //Se establece el pin D1 como bus OneWire/
//OneWire oneWire(ONE_WIRE_BUS);
//DallasTemperature sensors(&oneWire); //Se declara una variable u objeto para nuestro sensor

// #define DS18B20 5; //DS18B20 esta conectado al pin GPIO D5 del NodeMCU
//OneWire ourWire(DS18B20);// Se declara un objeto para la libreria
//DallasTemperature sensor(&ourWire);// Se declara un objeto para la otra libreria


WiFiClient client;// Se define el cliente wi-fi







 
void setup(void) 
{
 // Start Serial
  Serial.begin(9600);
  delay(10);
  
   pinMode(D0, WAKEUP_PULLUP);//
   delay(1000);// Esperamos 1 segundo
  
  // Start up the library
  sensors.begin();
  sensors.setResolution(12);

  // locate devices on the bus
  Serial.println("Locating devices...");
  Serial.print("Found ");
  deviceCount = sensors.getDeviceCount();
  Serial.print(deviceCount, DEC);
  Serial.println(" devices.");
  Serial.println("");
  
  Serial.println("Printing addresses...");
  for (int i = 0;  i < deviceCount;  i++)
  {
    Serial.print("Sensor ");
    Serial.print(i+1);
    Serial.print(" : ");
    sensors.getAddress(Thermometer, i);
    printAddress(Thermometer);
  }


 


pinMode(LED, OUTPUT);

    // We start by connecting to a WiFi network
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(200);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");  
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
 // Serial.println(temp);
  
   
  
   
}

  

 
void loop(void) 
{
  sensors.begin();
   sensors.requestTemperatures();    // Le pide el valor de temperatura al sensor
   sensors.setResolution(12);
      temp = sensors.getTempCByIndex(1);
      temp2 = sensors.getTempCByIndex(0);// Lee el valor de temperatura del sensor
   Serial.println(temp);
   Serial.println(temp2);
   
  int vcc = ESP.getVcc();          // Mide el voltaje a la entrada de la alimentacion del ESP8266 para evaluar cuanta carga le queda a la batería
 float vccVolt=1.096*vcc/1000;
   Serial.println(vccVolt);
  
//   float vdd = ESP.getVcc() / 1000.0;
 // int vcc = analogRead(A0);
 // float vccVolt=(vcc/1024.0)*5.0/100;   
 // Serial.println(vccVolt);
   
   if (client.connect(server,80))   // "184.106.153.149" or api.thingspeak.com
      {  
       String sendData = apiKey+"&field1="+String(temp)+"&field2="+String(temp2)+"&field3="+String(vccVolt)+"\r\n\r\n"; // En field 1 va la temperatura y en field 2 va el voltaje

       // Estableciendo conexion con Thingspeak
       client.print("POST /update HTTP/1.1\n");
       client.print("Host: api.thingspeak.com\n");
       client.print("Connection: close\n");
       client.print("X-THINGSPEAKAPIKEY: "+apiKey+"\n");
       client.print("Content-Type: application/x-www-form-urlencoded\n");
       client.print("Content-Length: ");
       client.print(sendData.length());
       client.print("\n\n");
       client.print(sendData);
      }


      
   //    delay(900000); //Tiempo de 10 minutos entre cada registro de temperatura
delay(1000);
   
  ESP.deepSleep(1.8e9); 
  
    delay(1.8e9);
   client.stop(); 
    client.flush(); 
      
      }

void printAddress(DeviceAddress deviceAddress)
{ 
  for (uint8_t i = 0; i < 8; i++)
  {
    Serial.print("0x");
    if (deviceAddress[i] < 0x10) Serial.print("0");
    Serial.print(deviceAddress[i], HEX);
    if (i < 7) Serial.print(", ");
  }
  Serial.println("");
}
